// TestWin32Dll.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <tchar.h>
#include <LoadMemoryDll.h>

int main(int argc, char* argv[])
{
	FILE *fp = fopen("Win32Dll.dll","rb");
	if(!fp)
		return 0;
	
	fseek(fp,0,SEEK_END);
	ULONG fSize = ::ftell(fp);
	fseek(fp,0,SEEK_SET);
	
	UCHAR *lpDllRawData = new UCHAR[fSize];
	fread(lpDllRawData,fSize,1,fp);
	fclose(fp);
	
	HMODULE hLib = DD_LoadLibrary(lpDllRawData,GetModuleHandle(0));
	if(!hLib)
	{
		MessageBox(NULL,_T("Load dll failed!"),_T(""),0);

		delete[] lpDllRawData;
		return 0;
	}
	else
	{
		delete[] lpDllRawData;

		void (*fTestFun)(LPCSTR);
		*(FARPROC*)&fTestFun = DD_GetProcAddress(hLib, "TestFun");
		if(fTestFun)
			fTestFun("Hello World!");
		
		DD_FreeLibrary(hLib);
	}	
	
	return 0;
}

